<template>
  <div>
    <div v-for="item in images" :key="item" class="room_img">
      <AuthImage :auth-src="getImageSrc(item)" />

      <span class="glyphicon glyphicon-trash" @click="removeImage(item)" />
    </div>
    <div>
      <div>
        <label for="workflowFile" class="label-btn"> {{ $t("lang.ImageListWidget.selectPicture") }} </label>
        <input
          id="workflowFile"
          autocomplete="off"
          type="file"
          class="inputfile"
          @change="onFileChange"
        />
      </div>
    </div>
    <Loading v-if="loading" />
  </div>
</template>

<script>


import AuthImage from '../widget/AuthImage.vue';

import {notificationError} from '../common/notification.js';
import Common from '../common/Common.js';

export default {

  components: {
    AuthImage,
  },
  props: {
    className: {
      type: String,
      default: null,
    },
  },

  data: function () {
    this.Common = Common;
    return {
      images: [],
      loading: false,
    };
  },

  methods: {
    /**
     * 删除图片
     * @param  {String} item 图片Name
     */
    removeImage(item) {
      var _self = this;
      var index = _self.images.indexOf(item);
      if (index > -1) {
        _self.images.splice(index, 1);
      }
    },

    /**
     * 选择图片发生改变
     * @param  {[type]} e [description]
     * @return {[type]}   [description]
     */
    onFileChange(e) {
      var files = e.target.files || e.dataTransfer.files;
      if (!files.length) return;
      this.uploadImage(files[0]);
    },

    /**
     * 上传图片
     * @param  {File} selectedFile 选择的文件
     */
    uploadImage: function (selectedFile) {
      var _self = this;
      if (selectedFile == undefined) {
        return;
      }

      if (!/image\/\w+/.test(selectedFile.type)) {
        alert('请确保文件为图像类型');
        return;
      }

      var formData = new FormData();
      formData.append('images', selectedFile);
      formData.append('className', _self.className);

      _self.loading=true;
      $.ajax({
        url: Common.getApiURL('file/imageUpload'),
        type: 'post',
        beforeSend: function (request) {
          Common.addTokenToRequest(request);
        },
        data: formData,
        contentType: false,
        processData: false,
        success: function (data) {
          _self.loading=false;
          console.log(data);
          if (data.errorCode == 0) {
            _self.addImgs(data.datas);
          }else{
            notificationError(data.errorMessage, '图片上传失败');
          }
        },
        error: function (XMLHttpRequest, textStatus, errorThrown) {
          _self.loading=false;
          Common.processException(XMLHttpRequest, textStatus, errorThrown);
        },
      });
    },

    /**
     * 添加图片
     * @param {String} imageName 添加的图片名称
     */
    addImgs: function (imageNames) {
      var _self = this;
      if(imageNames != null){
        imageNames.forEach(element => {
          _self.images.push(element);
        });
      }
    },

    /**
     * 获取图片地址
     * @param  {String} item 图片名称
     * @return {String}      图片URL地址
     */
    getImageSrc: function (item) {
      var _self = this;
      if (item != undefined && item != null) {
        return Common.getImageSrc(_self.className, item);
      } else {
        return '';
      }
    },

    /**
     * 获取图片路径供外部调用
     * @return {Array} 图片地址
     */
    getImages: function () {
      return this.images;
    },
  },
};
</script>

<style scoped>
.inputfile {
  width: 0.1px;
  height: 0.1px;
  opacity: 0;
  overflow: hidden;
  position: absolute;
  z-index: -1;
}

.room_img {
  width: 150px;
  height: 100px;
  float: left;
  margin-right: 10px;
}

.room_img img {
  width: 100%;
  height: 100%;
}

.room_img span {
  position: relative;
  right: -125px;
  top: -95px;
  font-size: 20px;
  color: #43a51e;
  cursor: pointer;
}

.label-btn {
  color: white;
  background-color: #006699;
  display: inline-block;
  padding: 5px 15px;
  border-radius: 5px;
}

.label-btn:hover {
  color: white;
  background-color: #003399;
  display: inline-block;
  padding: 5px 15px;
  border-radius: 5px;
  cursor: pointer;
}
</style>